//
//  MyDocument.m
//  ImageResizer
//
//  Created by Will Thimbleby on 01/10/2007.
//  Copyright __MyCompanyName__ 2007 . All rights reserved.
//

#import "MyDocument.h"

CIKernel *hSobel = nil, *vSobel;
CIFilter *hFilter, *vFilter;
CIContext *eciContext;
@implementation MyDocument

- (id)init
{
    self = [super init];
    if (self) {
    
        if(hSobel == nil)
		{
			NSString *kstr = [NSString stringWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"weighting" ofType:@"cikernel"]];
			NSArray *ks = [CIKernel kernelsWithString:kstr];
			hSobel = [[ks objectAtIndex:1] retain];
			vSobel = [[ks objectAtIndex:0] retain];
			hFilter = [[CIFilter alloc] init];
			vFilter = [[CIFilter alloc] init];
		}
    
    }
    return self;
}

- (NSString *)windowNibName
{
    // Override returning the nib file name of the document
    // If you need to use a subclass of NSWindowController or if your document supports multiple NSWindowControllers, you should remove this method and override -makeWindowControllers instead.
    return @"MyDocument";
}

- (void)windowControllerDidLoadNib:(NSWindowController *) aController
{
    [super windowControllerDidLoadNib:aController];
			
//	[[imgView window] setContentSize:NSMakeSize(CGImageGetWidth(mImage), CGImageGetHeight(mImage))];

	[self willChangeValueForKey:@"targetWidth"];
	[self willChangeValueForKey:@"targetHeight"];
	[self willChangeValueForKey:@"width"];
	[self willChangeValueForKey:@"height"];
	targetWidth = width = CGImageGetWidth(mImage);
	targetHeight = height = CGImageGetHeight(mImage);
	[self didChangeValueForKey:@"targetWidth"];
	[self didChangeValueForKey:@"targetHeight"];
	[self didChangeValueForKey:@"width"];
	[self didChangeValueForKey:@"height"];
	
	rowBytes = width * 4;
	sBuffer = malloc(rowBytes * height);
	pBuffer = malloc(rowBytes * height);
	eBuffer = malloc(rowBytes * height);
	
	CGColorSpaceRef bitmapColorSpace = CGColorSpaceCreateWithName(kCGColorSpaceGenericRGB);
	sContext = CGBitmapContextCreate(sBuffer, width, height, 8, rowBytes, bitmapColorSpace, kCGImageAlphaPremultipliedLast);
	eContext = CGBitmapContextCreate(eBuffer, width, height, 8, rowBytes, bitmapColorSpace, kCGImageAlphaPremultipliedLast);
//	CGContextScaleCTM(eContext, 1, -1);
//	CGContextTranslateCTM(eContext, 0, -height);
	CGContextDrawImage(sContext , CGRectMake(0, 0, CGImageGetWidth(mImage), CGImageGetHeight(mImage)), mImage);
	
	eciContext =[[CIContext contextWithCGContext:eContext options:NULL] retain];
	
	sImage = mImage;
	
	[self setFileType:@"Untitled Document"];
}

#pragma mark Files

- (BOOL)readFromURL:(NSURL *)absURL ofType:(NSString *)typeName error:(NSError **)outError
{
    BOOL status = NO;
    
    // Release and clear any old image variables
    mMetadata = nil;
    mImage = nil;

    // Load (or reload) the image
    CGImageSourceRef source = CGImageSourceCreateWithURL((CFURLRef)absURL, NULL);
    if (source == nil)
        goto bail;

    // build options dictionary for image creation that specifies: 
    //
    // kCGImageSourceShouldCache = kCFBooleanTrue
    //      Specifies that image should be cached in a decoded form.
    //
    // kCGImageSourceShouldAllowFloat = kCFBooleanTrue
    //      Specifies that image should be returned as a floating
    //      point CGImageRef if supported by the file format.

    NSDictionary* options = [NSDictionary dictionaryWithObjectsAndKeys:
                    (id)kCFBooleanTrue, (id)kCGImageSourceShouldCache,
                    (id)kCFBooleanTrue, (id)kCGImageSourceShouldAllowFloat,
                    nil];

    CGImageRef image = CGImageSourceCreateImageAtIndex(source, 0, (CFDictionaryRef)options);
    
    // Assign user preferred default profiles if image is not tagged with a profile
    mImage = CGImageCreateCopyWithDefaultSpace(image);
    mMetadata = (CFMutableDictionaryRef)CGImageSourceCopyPropertiesAtIndex(source, 0, (CFDictionaryRef)options);
    
	CFMakeCollectable(source);
	CFMakeCollectable(image);
	CFMakeCollectable(mImage);
	CFMakeCollectable(mMetadata);
	
    if (mImage != nil)
    {
	    status = YES;
	}

bail:
    
    if (status==NO && outError)
        *outError = [NSError errorWithDomain:NSCocoaErrorDomain code:NSFileReadCorruptFileError userInfo:nil];
    
    return status;
}

- (BOOL) writeToURL:(NSURL *)absURL ofType:(NSString *)typeName forSaveOperation:(NSSaveOperationType)saveOp 
         originalContentsURL:(NSURL *)absOrigURL error:(NSError **)outError
{
    BOOL status = NO;
    
    CGImageRef image = [self image];
    if (image==nil)
        goto bail;

    // Create an image destination writing to `url'
    CGImageDestinationRef dest = CGImageDestinationCreateWithURL((CFURLRef)absURL, (CFStringRef)typeName, 1, nil);
    if (dest==nil)
        goto bail;

    CGImageDestinationAddImage(dest, image, NULL);//(CFDictionaryRef)[self saveMetaAndOpts]);

    status = CGImageDestinationFinalize(dest);

    CGImageRelease(image);

bail:

    if (status==NO && outError)
        *outError = [NSError errorWithDomain:NSCocoaErrorDomain code:NSFileWriteUnknownError userInfo:nil];
    
    return status;
}

#pragma mark File types

// Return the names of the types for which this class can be instantiated to play the 
// Editor or Viewer role.  
//
+ (NSArray*)readableTypes
{
	NSLog(@"heel");
    return [(NSArray*)CGImageSourceCopyTypeIdentifiers() autorelease];
}


// Return the names of the types which this class can save. Typically this includes all types 
// for which the application can play the Viewer role, plus types than can be merely exported by 
// the application.
//
+ (NSArray*)writableTypes
{
    return [NSArray arrayWithObject:@"public.png"];//[(NSArray*)CGImageDestinationCopyTypeIdentifiers() autorelease];
}


// Return YES if instances of this class can be instantiated to play the Editor role.
//
+ (BOOL)isNativeType:(NSString *)type
{
    return [[self readableTypes] containsObject:type];
}

#pragma mark Shrinking

#define imgAt(x, y) eBuffer[4*(x)+(y)*rowBytes]
#define pbAt(x, y) (pBuffer[(x)+(y)*width])

inline float min2(float a, float b)
{
	if(a < b) return a;
	return b;
}

inline float min3(float a, float b, float c)
{
	return min2(a, min2(b, c));
}

- (void)shrinkHorizontally
{
	int widthNow = CGImageGetWidth(sImage);
	int heightNow = CGImageGetHeight(sImage);
	if(targetWidth >= widthNow) return;
	
	CIImage *ciimg = [[CIImage alloc] initWithCGImage:sImage];
	[eciContext drawImage:[hFilter apply:hSobel, ciimg, nil] atPoint:CGPointZero fromRect:CGRectMake(0, 0, widthNow, heightNow)];
	[ciimg release];
	
	int x, y;
	for(x=0;x<widthNow;x++)
	{
		pBuffer[x] = imgAt(x, 0);
	}
	int diff = height-heightNow;
	for(y=1;y<heightNow;y++)
	for(x=0;x<widthNow;x++)
	{
		if(x == 0)
			pBuffer[x+y*width] = (float)imgAt(x, y+diff) + min2(pbAt(x, y-1), pbAt(x+1, y-1));
		else if(x==widthNow-1)
			pBuffer[x+y*width] = (float)imgAt(x, y+diff) + min2(pbAt(x, y-1), pbAt(x-1, y-1));
		else
			pBuffer[x+y*width] = (float)imgAt(x, y+diff) + min3(pbAt(x, y-1), pbAt(x+1, y-1), pbAt(x-1, y-1));
	}
	y = heightNow-1;
	float minv = FLT_MAX; int minx=0;
	for(x=0;x<widthNow-1;x++)
	{
		if(minv > pbAt(x, y))
		{
			minv = pbAt(x, y);
			minx = x;
		}
	}
/*	int i;
	for(y=0;y<height;y++)
		for(x=0;x<widthNow;x++)
		{	for(i=0;i<3;i++)
				eBuffer[x*4+i+y*rowBytes] = pbAt(x, y)/10;
			eBuffer[x*4+3+y*rowBytes] = 255;
		}
*/
	x = minx;
	for(y=heightNow-2;y>=0;y--)
	{
		int xx;
		for(xx=x;xx<widthNow-1;xx++)
			((float*)sBuffer)[xx+y*width] = ((float*)sBuffer)[xx+1+y*width];
		
//		sBuffer[x*4+y*rowBytes]=255;
		float a=FLT_MAX, b, c=FLT_MAX;
		if(x > 0) a = pbAt(x-1, y);
		b = pbAt(x, y);
		if(x < widthNow-1) c = pbAt(x+1, y);
		
		if(a<b && a<c)
			x--;
		else if(c<a && c<b)
			x++;
	}
	
	CGImageRelease(sImage);
	CGImageRef it = CGBitmapContextCreateImage(sContext);
	sImage = CGImageCreateWithImageInRect(it, CGRectMake(0,0,widthNow-1,heightNow));
	CGImageRelease(it);
}

- (void)shrinkVertically
{
	int widthNow = CGImageGetWidth(sImage);
	int heightNow = CGImageGetHeight(sImage);
	if(targetHeight >= heightNow) return;
	
	CIImage *ciimg = [[CIImage alloc] initWithCGImage:sImage];
	[eciContext drawImage:[vFilter apply:hSobel, ciimg, nil] atPoint:CGPointZero fromRect:CGRectMake(0, 0, widthNow, heightNow)];
	[ciimg release];

	int x, y;
	for(y=0;y<heightNow;y++)
	{
		pBuffer[y*width] = imgAt(0, y);
	}
	int diff = height-heightNow;
	for(x=1;x<widthNow;x++)
	for(y=0;y<heightNow;y++)
	{
		if(y == 0)
			pBuffer[x+y*width] = (float)imgAt(x, y+diff) + min2(pbAt(x-1, y), pbAt(x-1, y+1));
		else if(y==heightNow-1)
			pBuffer[x+y*width] = (float)imgAt(x, y+diff) + min2(pbAt(x-1, y), pbAt(x-1, y-1));
		else
			pBuffer[x+y*width] = (float)imgAt(x, y+diff) + min3(pbAt(x-1, y), pbAt(x-1, y+1), pbAt(x-1, y-1));
	}
	x = widthNow-1;
	float minv = FLT_MAX; int miny=0;
	for(y=0;y<heightNow;y++)
	{
		if(minv > pbAt(x, y))
		{
			minv = pbAt(x, y);
			miny = y;
		}
	}
/*	NSLog(@">>%f",minv);
	int i;
	for(y=0;y<height;y++)
		for(x=0;x<widthNow;x++)
		{	for(i=0;i<3;i++)
				eBuffer[x*4+i+y*rowBytes] = pbAt(x, y)/10;
			eBuffer[x*4+3+y*rowBytes] = 255;
		}
*/
	y = miny;
	for(x=widthNow-2;x>=0;x--)
	{
		int yy;
		for(yy=y;yy<heightNow-1;yy++)
			((float*)sBuffer)[x+yy*width] = ((float*)sBuffer)[x+(yy+1)*width];
/*		for(yy=0;yy<heightNow-1;yy++)
{		char r[4]={pbAt(x, yy),0,0,255};
		((float*)sBuffer)[x+yy*width] = ((float*)r)[0];
}		*/
//		sBuffer[x*4+y*rowBytes]=255;
		float a=FLT_MAX, b, c=FLT_MAX;
		if(y > 0) a = pbAt(x, y-1);
		b = pbAt(x, y);
		if(y < heightNow-1) c = pbAt(x, y+1);
		
		if(a<b && a<c)
			y--;
		else if(c<a && c<b)
			y++;
	}
	
	CGImageRelease(sImage);
	CGImageRef it = CGBitmapContextCreateImage(sContext);
	sImage = CGImageCreateWithImageInRect(it, CGRectMake(0,0,widthNow,heightNow-1));
	CGImageRelease(it);
}

- (void)shrink:(id)s
{
	[resizeButton setEnabled:NO];
	[targets setEnabled:NO];
	[NSThread detachNewThreadSelector:@selector(shrinkThread) toTarget:self withObject:NULL];
}

- (void)enable
{
	[resizeButton setEnabled:YES];
	[targets setEnabled:YES];
}

- (void)shrinkThread
{
	id arp = [[NSAutoreleasePool alloc] init];
	
	int widthNow = CGImageGetWidth(sImage);
	int heightNow = CGImageGetHeight(sImage);
	
	while((targetHeight < heightNow) || (targetWidth < widthNow))
	{
		[self shrinkVertically];
		[self shrinkHorizontally];
	
		[imgView setNeedsDisplay:YES];
		
		widthNow = CGImageGetWidth(sImage);
		heightNow = CGImageGetHeight(sImage);
	}
	
	[self performSelectorOnMainThread:@selector(enable) withObject:NULL waitUntilDone:NO];
	[arp release];
}

#pragma mark Accessors

- (CGImageRef)image
{
	return sImage;//CGBitmapContextCreateImage(eContext);
}

@end
